# PhpDependTask

Extends \Task

Runs the PHP_Depend software analyzer and metric tool.

Performs static code analysis on a given source base.

package | phing.tasks.ext.pdepend
author | Benjamin Schultz bschultz@proqrent.de
version | $Id: 7ef44b418426e61cb1ea3b8cf87b289d79f663aa $
since | 2.4.1

### Methods

## Nested adder, adds a set of files (nested fileset attribute).

    addFileSet(\FileSet $fs) : void

### Arguments

#### $fs

`\FileSet`

## Create object for nested analyzer element

    createAnalyzer() : \PhpDependAnalyzerElement

### Response

`\PhpDependAnalyzerElement`

## createLegacyRunner

    createLegacyRunner() : \PHP_Depend_TextUI_Runner

### Response

`\PHP_Depend_TextUI_Runner`

## Create object for nested logger element

    createLogger() : \PhpDependLoggerElement

### Response

`\PhpDependLoggerElement`

## createRunner

    createRunner() : object

### Response

`object`

## Loads configuration file

    getConfiguration() : null|\PHP_Depend_Util_Configuration

throws |

### Response

`null|\PHP_Depend_Util_Configuration`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## getFilesToParse

    getFilesToParse() : array

### Response

`array`

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Load the necessary environment for running PHP_Depend

    requireDependencies()

throws |

## Sets a list of filename extensions for valid php source code files

    setAllowedFileExtensions(string $fileExtensions)

### Arguments

#### $fileExtensions

`string`

List of valid file extensions

## Set the configuration file

    setConfigFile(\PhingFile $configFile)

### Arguments

#### $configFile

`\PhingFile`

The configuration file

## Set debugging On/Off

    setDebug(boolean $debug)

### Arguments

#### $debug

`boolean`

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Sets a list of exclude directories

    setExcludeDirectories(string $excludeDirectories)

### Arguments

#### $excludeDirectories

`string`

List of exclude directories

## Sets a list of exclude packages

    setExcludePackages(string $excludePackages)

### Arguments

#### $excludePackages

`string`

Exclude packages

## Set the input source file or directory

    setFile(\PhingFile $file)

### Arguments

#### $file

`\PhingFile`

The input source file or directory

## Set halt on error

    setHaltonerror(boolean $haltonerror)

### Arguments

#### $haltonerror

`boolean`

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## setPharLocation

    setPharLocation(string $pharLocation)

### Arguments

#### $pharLocation

`string`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Should PHP_Depend support projects with a bad documentation. If this option is set to <b>true</b>, PHP_Depend will treat the default package <b>+global</b> as a regular project package.

    setSupportBadDocumentation(boolean $supportBadDocumentation)

### Arguments

#### $supportBadDocumentation

`boolean`

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Should the parser ignore doc comment annotations?

    setWithoutAnnotations(boolean $withoutAnnotations)

### Arguments

#### $withoutAnnotations

`boolean`

## Validates the available analyzers

    validateAnalyzers()

throws |

## Validates the available loggers

    validateLoggers()

throws |

### Properties

## A php source code filename or directory

    file : \PhingFile

var |

### Type(s)

`\PhingFile`

## All fileset objects assigned to this task

    filesets : array<mixed,\FileSet>

var |

### Type(s)

`array<mixed,\FileSet>`

## List of allowed file extensions. Default file extensions are <b>php</b> and <p>php5</b>.

    allowedFileExtensions : \array<string>

var |

### Type(s)

`\array<string>`

## List of exclude directories. Default exclude dirs are <b>.git</b>, <b>.svn</b> and <b>CVS</b>.

    excludeDirectories : \array<string>

var |

### Type(s)

`\array<string>`

## List of exclude packages

    excludePackages : \array<string>

var |

### Type(s)

`\array<string>`

## Should the parse ignore doc comment annotations?

    withoutAnnotations : boolean

var |

### Type(s)

`boolean`

## Should PHP_Depend treat <b>+global</b> as a regular project package?

    supportBadDocumentation : boolean

var |

### Type(s)

`boolean`

## Flag for enable/disable debugging

    debug : boolean

var |

### Type(s)

`boolean`

## PHP_Depend configuration file

    configFile : \PhingFile

var |

### Type(s)

`\PhingFile`

## Logger elements

    loggers : array<mixed,\PhpDependLoggerElement>

var |

### Type(s)

`array<mixed,\PhpDependLoggerElement>`

## Analyzer elements

    analyzers : array<mixed,\PhpDependAnalyzerElement>

var |

### Type(s)

`array<mixed,\PhpDependAnalyzerElement>`

## Holds the PHP_Depend runner instance

    runner : \PHP_Depend_TextUI_Runner

var |

### Type(s)

`\PHP_Depend_TextUI_Runner`

## Flag that determines whether to halt on error

    haltonerror : boolean

var |

### Type(s)

`boolean`

## oldVersion

    oldVersion : boolean

var |

### Type(s)

`boolean`

## pharLocation

    pharLocation : string

var |

### Type(s)

`string`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`